https://www.c-plusplus.net/forum/topic/23609/feiertage-berechnen/5
// geht auch in C
// -------------- calen ---------------------------------------
//---- Algorithmen ----
//
/*uint8_t schaltjahr( uint16_t jahr ) {
//   Eingabe: Jahr
//   Ausgabe: 0 kein Schaltjahr       1 Schaltjahr
//
  if(  ((jahr % 4 == 0) 
    && (jahr % 100 != 0)) 
    || (jahr % 400 == 0) )
      return (uint8_t)1;
  return (uint8_t)0;
}
*/
uint8_t schaltjahr( uint16_t jahr ) { // kurzform
  if(  (jahr % 4 == 0) )
    return (uint8_t)1;
  return (uint8_t)0;
} // uint8_t schaltjahr( uint16_t jahr )
uint8_t monat_im_jahr(uint16_t jahr, uint16_t n) {
//
//  Eingabe: Jahr
//        Tagesnummer rel. zum Jahresanfang
//        (1=1.1.,2=2.1.,...365/366=31.12)
//  Ausgabe: Monat (1=Jan, 2=Feb, ... 12 = Dec)
//  Algorithmus von R. A. Stone
//
  uint8_t a;
  a = schaltjahr(jahr);
  if ( (int16_t)n > 59+a )
    n += 2-a;
  n += 91;
  return (uint8_t)((20*n)/611 - 2);
} // uint8_t monat_im_jahr(uint16_t jahr, uint16_t n)
uint8_t tag_im_monat(uint16_t jahr, uint16_t n) {
//
//  Eingabe: Jahr
//        Tagesnummer rel. zum Jahresanfang
//        (1=1.1.,2=2.1.,...365/366=31.12)
//  Ausgabe: Tag (1..31)
//  Algorithmus von R. A. Stone
//
  uint8_t	a;
  int16_t m;
  a = schaltjahr(jahr);
  if ( (int16_t)n > 59+a )
    n += 2-a;
  n += 91;
  m = (20*n)/611;
  return (uint8_t)(n - (611*m)/20);
} // uint8_t tag_im_monat(uint16_t jahr, uint16_t n)
uint16_t tagesnummer( uint16_t jahr, uint8_t monat, uint8_t tag ) {
//
//   Eingabe: Jahr
//            Monat (1=Jan, 2=Feb, ... 12 = Dec)
//            Tag   (1...31)
//   Ausgabe: Tagesnummer rel. zum Jahresanfang
//            (1=1.1.,2=2.1.,...365/366=31.12)
//   Algorithmus von Robertson
//
  int d, e;
  d= (monat+10)/13;
  e= tag+ (611*(monat+2))/20 - 2*d - 91;
  return e + schaltjahr(jahr)*d;
} // uint16_t tagesnummer( uint16_t jahr, uint8_t monat, uint8_t tag )
uint8_t wochentag_im_jahr(uint16_t jahr, uint16_t n) {
//
//  Eingabe:  Jahr, Tagesnummer
//  Ausgabe:  Wochentag (1=Mo,..., 6=Sa, 7=So)
//
  int j,c; uint8_t _wt_;
  j = (jahr-1) % 100;
  c = (jahr-1) / 100;
  _wt_=(uint8_t)((28+j+n+(j/4)+(c/4)+5*c) % 7);
  if(!_wt_)			//case 0: //	C'T // 7 dcf77 + rtc
    _wt_=7;
  return _wt_;
} // uint8_t wochentag_im_jahr(uint16_t jahr, uint16_t n)
char *strWochentagname_form( uint8_t TagNummer ) {
  switch (TagNummer) {
    case 1:
      return "Montag    ";
    case 2:
      return "Dienstag  ";
    case 3:
      return "Mittwoch  ";
    case 4:
      return "Donnerstag";
    case 5:
      return "Freitag   ";
    case 6:
      return "Samstag   ";
    case 7: //	RTC
      //case 0: //	C'T
      return "Sonntag   ";
    default: 
      return "ERROR     ";
  } // switch (TagNummer)
} // char *strWochentagname_form( uint8_t TagNummer )
char *strWochentagname( uint8_t TagNummer ) {
  static char WtName[11];
  strcpy( WtName, strWochentagname_form(TagNummer));
  *strstr( WtName, " ")=0;
  return WtName;
} // char *strWochentagname( uint8_t TagNummer )
char *strWochentagname_kurz( uint8_t TagNummer ) {
  static char WtName_kurz[3];
  strcpy(WtName_kurz, leftstr(strWochentagname_form(TagNummer), 2));
  return WtName_kurz;
} // char *strWochentagname_kurz( uint8_t TagNummer )
char* strMonatsname( uint8_t Monat ) {
  switch (Monat) {
    case 1:
      return "Januar";
    case 2:
      return "Februar";
    case 3:
      return "Maerz";
    case 4:
      return "April";
    case 5:
      return "Mai";
    case 6:
      return "Juni";
    case 7:
      return "Juli";
    case 8:
      return "August";
    case 9:
      return "September";
    case 10:
      return "Oktober";
    case 11:
      return "November";
    case 12:
      return "Dezember";
    default:
      return "ERROR";
  } // switch (Monat)
} // char* strMonatsname( uint8_t Monat )
char* strMonatsname_kurz( uint8_t Monat ) {
  static char strMtsName[4];
  strncpy(strMtsName, strMonatsname(Monat), 3);
  return strMtsName;
} // char* strMonatsname_kurz( uint8_t Monat )
/*int16_t ostersonntag(uint16_t jahr) {
//
//  Eingabe: Jahr
//  Ausgabe: Tagesnummer des Ostersonntag,
//        rel. zum Jahresanfang.
//  Algorithmus "Computus ecclesiasticus"
//
//  325 n.Chr. wurde Ostern auf den Sonntag nach
//  dem ersten Fruehlingsvollmond festgelegt. Damit
//  liegt Ostern zwischen dem 22. Maerz und
//  dem 25. April.
//
  int16_t gz, jhd, ksj, korr, so, epakte, n;
  gz = (jahr%19)+1;
  jhd = jahr/100+1;
  ksj = (3*jhd)/4-12;
  korr = (8*jhd+5)/25-5;
  so = (5*jahr)/4-ksj-10;
  epakte = (11*gz+20+korr-ksj) % 30;
  if ( (epakte == 25 && gz > 11) || epakte == 24 )
    epakte++;
  n = 44-epakte;
  if ( n < 21 )
    n = n + 30;
  n = n + 7 - (so+n) % 7;
  n += schaltjahr(jahr);
  return n+59;
} // int16_t ostersonntag(uint16_t jahr)
*/

uint8_t uint8_Monatstage( uint16_t jahr, uint8_t Monat ) {
//
//  Eingabe: Jahr, Monat
//  Ausgabe: Monatstage
//
  switch ((int)Monat) {
    case 1:
    case 3:
    case 5:
    case 7:
    case 8:
    case 10:
    case 12:
      return 31;
    case 2:
      return (uint8_t)(28 + schaltjahr(jahr));
    case 4:
    case 6:
    case 9:
    case 11:
      return 30;
    default:
      return 0;
  } // switch ((int)Monat)
} // uint8_t uint8_Monatstage( uint16_t jahr, uint8_t Monat )

/*uint8_t mesz( uint16_t jahr, uint16_t tij, uint8_t hour ) {
// Eingabe: Jahr, Tagesnummer, Hour
//  Ausgabe: MESZ 1:0
  unsigned char beginnMESZ = tagesnummer( jahr, 3, 31 );
  unsigned endeMESZ = tagesnummer( jahr, 10, 31 );
  uint8_t mo;

  mo=monat_im_jahr(jahr, tij);

  if(mo > 2 && mo < 11)				// 11, 12, 1 und 2 haben keine Sommerzeit
  { // auf Sommerzeit korrigieren
    while(wochentag_im_jahr(jahr, beginnMESZ) != 7)
      beginnMESZ--;
    while(wochentag_im_jahr(jahr, endeMESZ) != 7)
      endeMESZ--;

    if( tij>beginnMESZ && tij<endeMESZ )
      return (uint8_t)1;
    else
    { if( tij==beginnMESZ && hour>=2  )
        return (uint8_t)1;
      if( tij==endeMESZ && hour<3  )
        return (uint8_t)1;
    }
  } // if(mo > 2 && mo < 11)
  return (uint8_t)0;
} // uint8_t mesz( uint16_t jahr )
*/
